//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//-------------------------------------------------------------------------

// ai.h

//
// Pic Animations
//

#define AIPIC_WALK90L  1
#define AIPIC_WALK90R  2
#define AIPIC_WALK90L2 3
#define AIPIC_WALK90R2 4
#define AIPIC_WALK90L3 5
#define AIPIC_WALK90R3 6
#define AIPIC_WALK90L4 7
#define AIPIC_WALK90R4 8


//
// All different Monsters
//

#define MONSTER_UNKOWN 0
#define MONSTER_ZOMBIE 1

//
// AI States
//

#define AISTATE_IDLE    0 // happens when monster is not active yet
#define AISTATE_SEARCH  1 // search for a target
#define AISTATE_RAISE   2 // used for zombies, but it will work for anything.
#define AISTATE_HIT     3 // if actor gets hit by something, state changes after use

/**********************************************
All classes have the same functions, which
allows us to generically call any function.
**********************************************/

//
// Zombie class
//

class aiZombie
{
	public:
		aiZombie::aiZombie();
		void thinkMain(void);
	public:
		int spritenum;
		int health;
	private:
		void mobChangeAngle(long newang);
		void thinkWalk(void);
		void thinkAttack(void);
	private:
		static AIIMAGES aiTiles[];
		void aiChangeState(int state) { this->state = state; };
		int  aiGetState(void)         { return this->state; };
		int        state;
		int        animCycle;
		boolean    footing;
		spritetype *mesprite;
};


//
// Construction for AI
//
struct aiConstruct
{

	long       beginPic; // start tile pic
	long       endPic;   // end tile pic

	long       beginPic2; // some sprites have to entities(ex. zombies under ground).
	long       endPic2;   // some sprites have to entities(ex. zombies under ground).

	int        mesprite;
	int        aiNumber;  // what AI to use
};

//
// AI Functions that are not in classes
// usually deal with threading
//
void ai_Shutdown(void);
void ai_SpawnThread(aiConstruct thisAI);