// game_main.cpp

#include "game.h"

extern int  spriteNum1;

Game::Game()
{
	initframe      = 0;
	thisWeaponPic  = 0;
	ingame         = false;	
	exit_game      = false;
	scripts_loaded = false;
	loadingplague  = false;
	gameThread     = 0;
}
/*
====================================
void Game::init_system(void)
====================================
*/
void Game::init_system(void)
{
	printf("Initlizing Game....\n");
	build_func->Load_Pallete("LOOKUP.DAT");

	printf("Prepare to enter Blood....\n");
}
/*
===================================
void Game::Error(char *err, ...)
===================================
*/
void Game::Error(char *err, ...)
{
	char temp[10];
	build_func->SDL_Quit();
	printf(err);
	gets(temp);
	exit(0);
}

/*
================================
void Game::LoadingPlague(void)
================================
*/

void Game::LoadingPlague(void)
{
	loadingplague = true;
	//while(loadingplague)
	//	Sleep(5);
}

/*
===================================
void Game::EndLoadingPlague(void)
===================================
*/

void Game::EndLoadingPlague(void)
{
	loadingplague = false;
}

/*
====================================
void Game::g_LoadLevel(char *board)
====================================
*/
void Game::g_LoadLevel(char *board)
{
	bloodPlayer_t *thisPlayer = new bloodPlayer_t; // recreate player 0
	int  levelMusic = soundManager->cacheMusic("CBLOOD1");

	thisBoard = board;
	if(gameThread == NULL)
		gameThread = new thread_t(new program_t("game.c"));
	else
		gameThread->ShutdownThread();  // wait for level to load

	gamePlayers.clear();           // players get clearned on new level
	worldMobs.clear();			   // flush world mobs
	registeredAI.clear();		   // clear registered AI
	actorManager->ClearAI();	   // clear the list of active AI
	srand(time(NULL));			   // reset the random number generator
	guimanager->DrawLoading(board);

	if(scripts_loaded == false)
	{
		printf("Running System Script\n");
		thread_t *gameInit = new thread_t(new program_t("system.c"));
		gameInit->RunProgram();
		gameInit->WaitFor_Thread();
	}
	
	// Create the player on this client
	thisPlayer->health   = 100;

	build_func->Decrypt_Map(board,"temp.map");
	
	if(build_func->loadboard( "temp.map",&thisPlayer->posx, &thisPlayer->posy, &thisPlayer->posz, 
							  &thisPlayer->ang,&thisPlayer->sectorNum ) == -1 )
	{
		Error("g_LoadLevel: failed to find converted level 'temp.map'\n");
	}

	printf("....Putting player at %d %d %d\n",thisPlayer->posx,thisPlayer->posy,thisPlayer->posz);
	gamePlayers.push_back(thisPlayer); // assumed that it is the current player

	// Create weapons here...
	bloodWeapon_t *pitchFork = new bloodWeapon_t("pitch fork",1,-2,WEAPON_PITCHFORK);
	bloodWeapon_t *flareGun  = new bloodWeapon_t("Flare Gun",1,-1,WEAPON_PITCHFORK);

	gamePlayers.at(0)->playerweapons.push_back(pitchFork);
	gamePlayers.at(0)->playerweapons.push_back(flareGun);

	gamePlayers.at(0)->thisWeapon = PLAYER_WEAPON_PITCHFORK;

	ingame = true;

	//Level_MakeActors();		// assign monsters to AI

	// First weapon player starts with
	//gameThread->RunProgram();			// restart the game

	SetPlayerWeapon(0); // pitchfork
	soundManager->PlayMusic(levelMusic);
}
/*
===============================
void Game::DisplayLevel(void)
===============================
*/
void Game::DisplayLevel(void)
{
	bloodPlayer_t *thisPlayer = gamePlayers.at(0);
	short pskyoff[256];     
	if(ingame == false)
		return;

	pskyoff[0]=1; pskyoff[1]=2; pskyoff[2]=1; pskyoff[3]=3;
    pskyoff[4]=4; pskyoff[5]=0; pskyoff[6]=2; pskyoff[7]=3;

	build_func->Justin_SetSky(65536L,pskyoff);
	build_func->displayLevel(thisPlayer->posx,thisPlayer->posy,thisPlayer->posz,thisPlayer->ang,thisPlayer->sectorNum,65536);
}

/*
====================================
int Game::RunFrame(int totalclock)
====================================
*/
boolean Game::g_PlayerInGame(void)
{
	return this->ingame;
}

/*
===================================================================
void Game::DrawHudNumber(int number, int startfont, int shade,int x, int y)
===================================================================
*/

void Game::DrawHudNumber(int number, long startfont, int shade, int x, int y)
{
	char thisText[20];
	sprintf(thisText,"%d",number);
	guimanager->DrawTextCustom(thisText,startfont,shade,x,y);
}

/*
=========================================
void Game::ShutdownWeaponThreads(void)

Shutdown ALL weapon threads, regardless
if they are on.  This ensures only one
weapon thread is running, which saves
memory.
=========================================
*/

void Game::ShutdownWeaponThreads(void)
{
	for(int i = 0; i < playerWeapons.size(); i++)
	{
		playerWeapons.at(i)->ShutdownThread();
	}
}

/*
==========================
void Game::DrawHUD(void)
==========================
*/

void Game::DrawHUD(void)
{
	bloodPlayer_t *thisPlayer = gamePlayers.at(0);
	if(ingame == false)
		return;

	if(!(thisWeaponX2 == 0 && thisWeaponY2 == 0 && thisWeaponPic2 == 0))
		build_func->rotatesprite(thisWeaponX2<<16,thisWeaponY2-4<<16,65536L,0,thisWeaponPic2,16,0,10,0,0,800-1,600-1);
	if(!(thisWeaponX == 0 && thisWeaponY == 0 && thisWeaponPic == 0))
		build_func->rotatesprite(thisWeaponX<<16,thisWeaponY-4<<16,65536L,0,thisWeaponPic,16,0,10,0,0,800-1,600-1);

	
	build_func->rotatesprite(160<<16,172<<16,65536L,0,STAUSBAR,16,0,10,0,0,800-1,600-1);
	DrawHudNumber(gamePlayers.at(0)->health,2190,10,85,183);
}

/*
============================
void Game::Shutdown(void)
============================
*/

void Game::Shutdown(void)
{
	printf("Shutting down game\n");
}

/*
================================================
void Game::Register_Weapon(char *weaponScript)
================================================
*/

void Game::Register_Weapon(char *weaponScript)
{
	thread_t *thisWeapon = new thread_t(new program_t(weaponScript));
	printf("Registered Weapon %s\n",weaponScript);
	playerWeapons.push_back(thisWeapon);
}

/*
===================================
void Game::ShotWeapon(int damage)
===================================
*/

void Game::ShotWeapon(int damage)
{

}

/*
===========================================
void Game::SetPlayerWeapon(int weaponNum)
===========================================
*/

void Game::SetPlayerWeapon(int weaponNum)
{
	if(weaponNum < 0 || weaponNum >=playerWeapons.size())
	{
		printf("SetClientWeapon: Range out of bounds %d\n",weaponNum);
		return;
	}
	
	if(weaponInUse == weaponNum)
		return;

	ShutdownWeaponThreads();
	
	// reset the weapon variables
	thisWeaponPic  = 0;
	thisWeaponX    = 0;
	thisWeaponY    = 0;

	thisWeaponPic2 = 0;
	thisWeaponX2   = 0;
	thisWeaponY2   = 0;

	spriteNum1     = -2; // no assigned ent
	playerWeapons.at(weaponNum)->RunProgram();
	weaponInUse = weaponNum;
}

/*
===================================
void Game::P_HandleMovement(void)
===================================
*/

void Game::P_HandleMovement(void)
{
	int turnamount = NORMALTURN;
	int keymove = NORMALKEYMOVE;
	long momx,momy;
	long fvel=0, svel=0, avel=0;
	long globhiz=0, globhihit=0, globloz=0,globlohit=0;
	long goalz;

	bloodPlayer_t *thisPlayer = gamePlayers.at(0); // client movement only happens with 0 player(you).
	
	if(thisPlayer->health < 0) // dead people can't move
		return;

	momx = momy = 0;

	if (!build_func->build_KeyDown(sc_LeftAlt))
	{
		if (build_func->build_KeyDown(sc_A)) avel-= turnamount;
		if (build_func->build_KeyDown(sc_D)) avel+= turnamount;
	}
	else
	{
		if (build_func->build_KeyDown(sc_A)) avel -= PREAMBLETURN;
		if (build_func->build_KeyDown(sc_D)) avel += PREAMBLETURN;
	}

	if (build_func->build_KeyDown(sc_W)) // FORWARD
	{
			fvel += keymove;
	}

	if (build_func->build_KeyDown(sc_S)) // BACK
	{
			fvel += -keymove;
	}

	if (build_func->build_KeyDown(sc_V)) // SIDESTEP LEFT
	{
			svel += keymove;
	}

	if (build_func->build_KeyDown(sc_B)) // SIDESTEP RIGHT
	{
			svel += keymove;
	}

	if(svel == 0)
		svel = fvel;

	if (build_func->build_KeyDown(sc_A))
		thisPlayer->ang-=turnamount;

	if (build_func->build_KeyDown(sc_D))
		thisPlayer->ang+=turnamount;

	if (build_func->build_KeyDown(sc_LeftShift))
		fvel *= 4;
	if(fvel < -MAXVEL) fvel = -MAXVEL;
	if(fvel > MAXVEL) fvel = MAXVEL;
	if(svel < -MAXSVEL) svel = -MAXSVEL;
	if(svel > MAXSVEL) svel = MAXSVEL;
	if(avel < -MAXANGVEL) avel = -MAXANGVEL;
	if(avel > MAXANGVEL) avel = MAXANGVEL;
	// if(horiz < -MAXHORIZ) horiz = -MAXHORIZ;
	// if(horiz > MAXHORIZ) horiz = MAXHORIZ;

	//printf("%d\n",thisPlayer->svel);
	
	momx = build_func->mulscale(fvel,build_func->sintable[(thisPlayer->ang+512)&2047],1);
	momy = build_func->mulscale(-fvel,build_func->sintable[(thisPlayer->ang+2047)],1);

	momx += build_func->mulscale(svel,build_func->sintable[(thisPlayer->ang+2047)],1);
	momy += build_func->mulscale(svel,build_func->sintable[(thisPlayer->ang-512)&2047],1);
	

	if(thisPlayer->ang > 2048)
		thisPlayer->ang = 0;

	if(thisPlayer->ang < 0)
		thisPlayer->ang = 2048;

	build_func->clipmove(&thisPlayer->posx,&thisPlayer->posy,&thisPlayer->posz,&thisPlayer->sectorNum,momx,momy,128L,4<<8,4<<8,CLIPMASK0);
	gamePlayers.at(0) = thisPlayer; 
		
	// Handle Z movement
	build_func->getzrange(thisPlayer->posx,thisPlayer->posy,thisPlayer->posz,thisPlayer->sectorNum,&globhiz,&globhihit,&globloz,&globlohit,128L,CLIPMASK0);

	goalz = globloz-15000;

	thisPlayer->posz = goalz;
	// Instant death, either stuck in a wall, or under crusher
	if(build_func->pushmove(&thisPlayer->posx,&thisPlayer->posy,&thisPlayer->posz,&thisPlayer->sectorNum,128L,(4L<<8),(20L<<8),CLIPMASK0)==-1)
		gamePlayers.at(0)->health = -1000;
}

/*
==================================
void Game::RemoveEffectors(void)
==================================
*/

void Game::RemoveEffectors(void)
{
	spritetype *thisSprite;
	int        spriteNum = 0;

	while( 1 )// Loop through all the game sprites
	{
		thisSprite = build_func->Game_GetSprite(spriteNum);

		if(thisSprite == NULL) // reached end of max sprites in level
			return;

		for(int i = 0; i < removeSprites.size(); i++)
		{
			if(thisSprite->picnum == removeSprites.at(i))
				thisSprite->cstat = (short)32768;
		}
		spriteNum++;
	}; 
}

/*
====================================================================
void Game::RegisterAI(int startPic, int endPic, char *script_name)
====================================================================
*/

void Game::RegisterAI(int startPic, int endPic, char *script_name)
{
	monster_t *thisMob = new monster_t;
	printf("Registering AI: (%d -> %d) %s\n",startPic,endPic,script_name);

	thisMob->mobAI    = new thread_t(new program_t(script_name));
	thisMob->startPic = startPic;
	thisMob->endPic   = endPic;

	registeredAI.push_back(thisMob);
}

/*
================================================================
void Game::ModifySprite(int spriteNum, spritetype *thisSprite)
================================================================
*/

void Game::ModifySprite(int spriteNum, spritetype *thisSprite)
{
	spritetype *thisSpriteLocal = build_func->Game_GetSprite(spriteNum);
    thisSpriteLocal             = thisSprite;
}

/*
==========================
void Game::StartAI(void)
==========================
*/

void Game::StartAI(void)
{
	monster_t *thisMob;
	spritetype *thisSprite;
	int        spriteNum = 0;

	while( 1 )// Loop through all the game sprites
	{
		thisSprite = build_func->Game_GetSprite(spriteNum);

		if(thisSprite == NULL) // reached end of max sprites in level
			return;

		if(registeredAI.size() == 0)
			printf("WARNING: No registered ai?\n");

		for(int i = 0; i < registeredAI.size(); i++)
		{
			//thisMob = registeredAI.at(i);
			thisMob   = new monster_t;

			thisMob->endPic   = registeredAI.at(i)->endPic;
			thisMob->startPic = registeredAI.at(i)->startPic;
			thisMob->mobAI    = new thread_t(new program_t("monster_ai_cult.c"));

            if(thisSprite->picnum >= thisMob->startPic && thisSprite->picnum <= thisMob->endPic)
			{
				monsterEnt_t *thisEnt = new monsterEnt_t;
	
				thisEnt->thisMob = thisMob;
				thisEnt->mobID   = spriteNum;
				thisEnt->aiNum   = i;
				thisEnt->thisMob->mobAI->thisEntNum = spriteNum;  
				thisEnt->thisMob->mobAI->RunProgram();

				worldMobs.push_back(thisEnt); // keep track of our entities
				break;
			}
		}
		spriteNum++;
	}; 
}

/*
=============================
void Game::ShutdownAI(void)
=============================
*/

void Game::ShutdownAI(void)
{
	// Stop all AI threads
	printf("Game: Shutting down AI threads FIXME\n");

	for(int i = 0; i < worldMobs.size(); i++)
	{
		worldMobs.at(i)->thisMob->mobAI->ShutdownThread();
	}
	registeredAI.clear();
}

/*
=============================
void Game::ShutdownAI(void)
=============================
*/

void Game::SuspendAI(void)
{
	// Stop all AI threads
	for(int i = 0; i < worldMobs.size(); i++)
	{
		worldMobs.at(i)->thisMob->mobAI->ShutdownThread();
	}
}

/*
=============================
void Game::ShutdownAI(void)
=============================
*/

void Game::ReRunAI(void)
{
	// Stop all AI threads
	for(int i = 0; i < worldMobs.size(); i++)
	{
		worldMobs.at(i)->thisMob->mobAI->RunProgram();
	}
}

/*
===================================
void Game::Level_MakeActors(void)
===================================
*/

void Game::Level_MakeActors(void)
{
	// Regiser ALL actors that are in game.
//	bloodEntity_t *monster_CultGuy = new bloodEntity_t(2820,90,-1,-1
//													   2860,
}

/*
====================================
int Game::RunFrame(int totalclock)
====================================
*/

int Game::RunFrame(int totalclock)
{
	if(initframe != 1)
	{
		srand(time(NULL));
		init_system();
		g_LoadLevel("E4M1.MAP");
		initframe = 1;
		RemoveEffectors();

		// NASTY UGLY HACK for WEAPON BUG
	//	SetPlayerWeapon(0);
		gameThread->RunProgram();
		StartAI();
	}


	if(exit_game)
		return 0;

	if(build_func->build_KeyDown(sc_Q))      // quick escape
		return 0;

	if(build_func->build_KeyDown(sc_Escape)) // menu key is hard coded
	{
		SuspendAI();
		menuManager->SetMenu(BLOODMENU_ESC);
	}

	guimanager->Init2D();    // this always needs to be first call

	actorManager->blood_RunAI(); // run the AI for this frame

	DisplayLevel();			 // draw the level

	if(menuManager->MenuActive() == true)
		P_HandleMovement();      // move the player position for this frame
	
	DrawHUD();				 // draw the players hud

	menuManager->DrawMenu(); // menu gets drawn before everything else except the loading screen

	if(menuManager->MenuActive() == false)
		build_func->nextpage(); // this is always the last call, except in menus
	return 1; // frame is OK
}